﻿Public Class Functions
    'この二つで、押してるキーに対応するc.key_judge()の要素がtrueになるんで、今現在どのキーが押されてるかがわかるよ

    Public Shared Sub k_down(ByVal e As System.Windows.Forms.KeyEventArgs)

        If e.KeyCode = Keys.Left Then
            c.key_judge(0) = True
        ElseIf e.KeyCode = Keys.Right Then
            c.key_judge(1) = True
        End If

        If e.KeyCode = Keys.Up Then
            c.key_judge(2) = True
        ElseIf e.KeyCode = Keys.Down Then
            c.key_judge(3) = True
        End If

        If e.KeyCode = Keys.Z Then
            c.key_judge(4) = True
        ElseIf e.KeyCode = Keys.X Then
            c.key_judge(5) = True
        ElseIf e.KeyCode = Keys.C Then
            c.key_judge(6) = True
        End If

        If e.KeyCode = Keys.Enter Then
            c.key_judge(7) = True
        ElseIf e.KeyCode = Keys.Escape Then
            c.key_judge(8) = True
        End If

        If e.KeyCode = Keys.Q Then
            c.key_judge(9) = True
        End If

    End Sub

    Public Shared Sub k_up(ByVal e As System.Windows.Forms.KeyEventArgs)

        If e.KeyCode = Keys.Left Then
            c.key_judge(0) = False
        ElseIf e.KeyCode = Keys.Right Then
            c.key_judge(1) = False
        End If

        If e.KeyCode = Keys.Up Then
            c.key_judge(2) = False
        ElseIf e.KeyCode = Keys.Down Then
            c.key_judge(3) = False
        End If

        If e.KeyCode = Keys.Z Then
            c.key_judge(4) = False
        ElseIf e.KeyCode = Keys.X Then
            c.key_judge(5) = False
        ElseIf e.KeyCode = Keys.C Then
            c.key_judge(6) = False
        End If

        If e.KeyCode = Keys.Enter Then
            c.key_judge(7) = False
        ElseIf e.KeyCode = Keys.Escape Then
            c.key_judge(8) = False
        End If

        If e.KeyCode = Keys.Q Then
            c.key_judge(9) = False
        End If


    End Sub

    Public Shared Sub first_init()

        'form1がロードされたときにとりあえずみんなnew()しときます
        Sound.init()

        c.jiki = New Jiki
        c.boss = New Boss
        c.back_drawer = New Base

        '背景はクラス作ってないんでここで設定しちゃいます
        c.back_drawer.x = 0
        c.back_drawer.y = -100
        c.back_drawer.z = 0
        c.back_drawer.exist = True
        c.back_drawer.kind = 0
        c.back_drawer.size = 600


        For i As Integer = 0 To c.teki_num - 1
            c.teki(i) = New Teki
        Next

        For i As Integer = 0 To c.bull_num - 1
            c.bullet(i) = New Bullet
        Next

        For i As Integer = 0 To c.item_num - 1
            c.item(i) = New Item
        Next

        For i As Integer = 0 To c.effect_num - 1
            c.effect(i) = New effect
        Next



        'とりあえずキー入力全くなし、にしとく
        For i As Integer = 0 To 9
            c.key_judge(i) = False
        Next


        '画像を変数に読み込む

        c.boss_img(0) = Image.FromFile(Application.StartupPath & "\image\jiki.png")
        c.boss_img(1) = Image.FromFile(Application.StartupPath & "\image\wood.png")
        c.boss_img(2) = Image.FromFile(Application.StartupPath & "\image\kappa.png")
        c.boss_img(3) = Image.FromFile(Application.StartupPath & "\image\TV.png")
        c.boss_img(4) = Image.FromFile(Application.StartupPath & "\image\Fuji.png")
        c.boss_img(5) = Image.FromFile(Application.StartupPath & "\image\oni.png")

        c.teki_img(0) = Image.FromFile(Application.StartupPath & "\image\tama.png")
        c.teki_img(1) = Image.FromFile(Application.StartupPath & "\image\kabe.png")
        c.teki_img(2) = Image.FromFile(Application.StartupPath & "\image\glico.png")
        c.teki_img(3) = Image.FromFile(Application.StartupPath & "\image\kimoi.png")
        c.teki_img(4) = Image.FromFile(Application.StartupPath & "\image\hituji.png")

        c.bullet_img(0) = Image.FromFile(Application.StartupPath & "\image\pink.png")
        c.bullet_img(1) = Image.FromFile(Application.StartupPath & "\image\white.png")
        c.bullet_img(2) = Image.FromFile(Application.StartupPath & "\image\orange.png")
        c.bullet_img(3) = Image.FromFile(Application.StartupPath & "\image\black.png")
        c.bullet_img(4) = Image.FromFile(Application.StartupPath & "\image\parple.png")
        c.bullet_img(5) = Image.FromFile(Application.StartupPath & "\image\green.png")
        c.bullet_img(6) = Image.FromFile(Application.StartupPath & "\image\light_blue.png")
        c.bullet_img(7) = Image.FromFile(Application.StartupPath & "\image\yellow.png")
        c.bullet_img(8) = Image.FromFile(Application.StartupPath & "\image\red.png")
        c.bullet_img(9) = Image.FromFile(Application.StartupPath & "\image\blue.png")
        c.bullet_img(10) = Image.FromFile(Application.StartupPath & "\image\leaf.png")
        c.bullet_img(11) = Image.FromFile(Application.StartupPath & "\image\water.png")
        c.bullet_img(12) = Image.FromFile(Application.StartupPath & "\image\thunder.png")
        c.bullet_img(13) = Image.FromFile(Application.StartupPath & "\image\fire.png")
        c.bullet_img(14) = Image.FromFile(Application.StartupPath & "\image\porn.png")

        c.item_img(0) = Image.FromFile(Application.StartupPath & "\image\heart.png")
        c.item_img(1) = Image.FromFile(Application.StartupPath & "\image\heart2.png")
        c.item_img(2) = Image.FromFile(Application.StartupPath & "\image\upper.png")

        c.effect_img(0) = Image.FromFile(Application.StartupPath & "\image\explosion1.png")
        c.effect_img(1) = Image.FromFile(Application.StartupPath & "\image\explosion2.png")
        c.effect_img(2) = Image.FromFile(Application.StartupPath & "\image\explosion3.png")
        c.effect_img(3) = Image.FromFile(Application.StartupPath & "\image\explosion4.png")
        c.effect_img(4) = Image.FromFile(Application.StartupPath & "\image\explosion5.png")

        c.back_img(0) = Image.FromFile(Application.StartupPath & "\image\opening.png")
        c.back_img(1) = Image.FromFile(Application.StartupPath & "\image\dead.png")
        c.back_img(2) = Image.FromFile(Application.StartupPath & "\image\back.png")
        c.back_img(3) = Image.FromFile(Application.StartupPath & "\image\continue.png")
        c.back_img(4) = Image.FromFile(Application.StartupPath & "\image\end_roll.png")
        c.back_img(5) = Image.FromFile(Application.StartupPath & "\image\1st_clear.png")
        c.back_img(6) = Image.FromFile(Application.StartupPath & "\image\2nd_clear.png")
        c.back_img(7) = Image.FromFile(Application.StartupPath & "\image\3rd_clear.png")
        c.back_img(8) = Image.FromFile(Application.StartupPath & "\image\4th_clear.png")
        c.back_img(9) = Image.FromFile(Application.StartupPath & "\image\final_clear.png")


        '敵やらボスやらの各ステージごとの動きのパターンを入力します


        Boss.pattern(0) = New Integer(22) {1, -30, 3, -30, 7, -30, 12, -30, 2, -30,
                                           4, -30, 14, -30, 17, -100, 7, -30, 17, -100,
                                           16, -30, 0}

        Boss.pattern(1) = New Integer(34) {14, -50, 14, -50, 14, -50, 1, -50, 2, -50,
                                          5, -50, 3, -50, 4, -50, 6, -50, 12, -50,
                                          7, -50, 18, -100, 12, -50, 7, -50, 18, -100,
                                          13, -50, 15, -50, 0}

        Boss.pattern(2) = New Integer(32) {19, -50, 11, -50, 1, -50, 6, -50, 3, -50,
                                          5, -50, 13, -20, 13, -20, 13, -50, 14, -30,
                                           14, -30, 14, -100, 19, -50, 16, -50, 8, -50,
                                           15, -50, 0}

        Boss.pattern(3) = New Integer(38) {8, -50, 7, -50, 11, -50, 20, -50, 12, -50,
                                          12, -50, 12, -50, 12, -50, 12, -50, 2, -50,
                                          4, -50, 20, -100, 9, -50, 10, -50, 13, -50,
                                          20, -120, 14, -30, 14, -30, 14, -50, 0}

        Boss.pattern(4) = New Integer(62) {8, -50, 7, -50, 10, -50, 7, -50, 9, -50,
                                          18, -50, 5, -50, 6, -100, 19, -50, 7, -50,
                                          8, -50, 11, -50, 20, -100, 21, -50, 7, -50,
                                          21, -50, 8, -50, 21, -50, 10, -50, 20, -100,
                                           21, -50, 9, -50, 2, -50, 4, -50, 5, -50,
                                           6, -50, 21, -100, 19, -50, 21, -50, 18, -50,
                                           20, -100, 0}


        Teki.pattern(0) = New Integer(20) {1, -100, 2, -100, 3, -100, 4, -100, 5, -100,
                                           6, -100, 7, -100, 8, -100, 9, -200, 10, -200, 0}

        Teki.pattern(1) = New Integer(20) {1, -100, 1, -100, 2, -100, 3, -100, 2, -100,
                                           4, -130, 1, -100, 2, -100, 3, -130, 4, -100, 0}

        Teki.pattern(2) = New Integer(14) {1, -50, 1, -50, 3, -100, 1, -500, 2, -100,
                                           3, -100, 1, -200, 0}

        Teki.pattern(3) = New Integer(20) {1, -70, 5, -70, 2, -70, 5, -70, 3, -70,
                                           5, -70, 4, -70, 5, -70, 5, -70, 5, -100, 0}

        Teki.pattern(4) = New Integer(18) {1, -100, 1, -100, 2, -50, 1, -100, 4, -50,
                                           5, -50, 1, -100, 3, -50, 2, -120, 0}

    End Sub

    Public Shared Sub init_base()  'みんな消えてもらいます

        c.jiki.set_c(250, c.y_max - 3 * c.l_size, 0)
        c.jiki.set_v(0, 0, 0)
        c.jiki.exist = True

        c.boss.exist = False

        For i As Integer = 0 To c.teki_num - 1
            c.teki(i).disappear()
        Next

        For i As Integer = 0 To c.bull_num - 1
            c.bullet(i).disappear()
        Next

        For i As Integer = 0 To c.effect_num - 1
            c.effect(i).disappear()
        Next

        For i As Integer = 0 To c.item_num - 1
            c.item(i).disappear()
        Next

    End Sub

    Public Shared Sub re_try()
        init_base()
        '3面の緑やろーが消えないように
        If c.stage(0) = 3 And Teki.teki_end_flg Then
            For i As Integer = 0 To c.teki_num - 1
                If c.teki(i).kind = 2 And c.teki(i).action >= 100 Then
                    c.teki(i).exist = True
                End If
            Next
        End If


        '死んだけど残機がまだあるとき、teki, bossのうちプレイ中だったところを初めからやり直し

        Teki.wait_count = 0
        Teki.sequence = 0
        Teki.num_count = 0

        Boss.sequence = 0
        Boss.wait_count = 0
        Boss.num_count = 0

        If c.stage(1) = 1 Then
            Boss.appear(True)
        End If

    End Sub
    Public Shared Sub dead()

        c.sequence = 3

    End Sub

    Public Shared Sub start()
        '一番初めのときと、残機が0になって、スタート画面に戻ったあともう一回ゲームする時の初期化関数(1面の初めからです)
        init_base()

        c.jiki.set_s(True, 0, 5, c.l_size, 0)  '5回まで死ねる

        Boss.sequence = 0
        Boss.wait_count = 0
        Boss.num_count = 0

        Teki.wait_count = 0
        Teki.sequence = 0
        Teki.teki_end_flg = False
        Teki.num_count = 0

        c.score = 0
        c.count = 0
        c.stage = {1, 0}
    End Sub

    Public Shared Sub clear()
        'ステージクリア時に実行
        init_base()
        If c.stage(0) = 5 Then
            c.stage(0) += 1
            c.sequence = 4
            
        Else

            Teki.wait_count = 0
            Teki.sequence = 0
            Boss.sequence = 0
            Boss.wait_count = 0
            Boss.num_count = 0
            Teki.teki_end_flg = False
            Teki.num_count = 0

            c.stage(0) += 1
            c.stage(1) = 0
            c.sequence = 2
        End If

    End Sub

    Public Shared Sub fall()  '重力を働かせる
        c.jiki.gravity()
        c.boss.gravity()

        For i As Integer = 0 To c.teki_num - 1
            c.teki(i).gravity()
        Next

        For i As Integer = 0 To c.bull_num - 1
            If c.jiki.size - c.bullet(i).size > 0 Then
                c.bullet(i).gravity()
            Else
                c.bullet(i).gravity()
            End If

        Next

        For i As Integer = 0 To c.item_num - 1
            c.item(i).gravity()
        Next

    End Sub

End Class
